﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ObjectsDemo.Parts;
using ObjectsDemo.Planes;
using ObjectsDemo;

namespace ObjectsDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            Engine engine;
            Plane plane;
            FuelTank tank;

            engine = new Engine();
            plane = new Plane();
            tank = new FuelTank();

            plane.engine = engine;
            plane.fuel = tank;
            plane.weight = 1000;
            engine.consumption = 1000;
            engine.thrust = 1000;
            tank.setCapacity(10000);
            tank.refuel(10000);
            Console.WriteLine(plane);
            Console.WriteLine("Plane flies 2 hours:" + plane.fly(2));
            Console.WriteLine(plane);
            Console.WriteLine("Plane flies 9 hours:" + plane.fly(9));
            Console.WriteLine(plane);
            
            Console.ReadLine();
        }
    }

    namespace Parts
    {
        class Engine
        {
            public double thrust { get; set;}
            public double consumption { get; set;}


            public override string ToString()
            {
                return "Engine: consumption:" + consumption + ", thrust:" + thrust;
            }
        }
    }

    namespace Planes
    {
        class Plane
        {
            public Engine engine { set; get; }
            public FuelTank fuel { set; get; }
            public double weight { set; get; }

            public bool fly(int hours)
            {
                if (CanFly(hours))
                {
                    return fuel.consume( hours * engine.consumption);
                }
                return false;
            }

            private bool CanFly(int hours)
            {
                return engine.consumption * hours <= fuel.fuel
                    && weight <= engine.thrust;
            }

            public override string ToString()
            {
                return "Plane: weigth: " + weight + ", " + fuel + ", " + engine;
            }
        }
    }
}
